servi/org.eclipse.statet.rj.servi.webapp/src/main/java/org/eclipse/statet/rj/servi/webapp/DebugBean.java
/*=============================================================================#
 # Copyright (c) 2009, 2022 Stephan Wahlbrink and others.
 # 
 # This program and the accompanying materials are made available under the
 # terms of the Eclipse Public License 2.0 which is available at
 # https://www.eclipse.org/legal/epl-2.0, or the Apache License, Version 2.0
 # which is available at https://www.apache.org/licenses/LICENSE-2.0.
 # 
 # SPDX-License-Identifier: EPL-2.0 OR Apache-2.0
 # 
 # Contributors:
 #     Stephan Wahlbrink <sw@wahlbrink.eu> - initial API and implementation
 #=============================================================================*/

package org.eclipse.statet.rj.servi.webapp;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.annotation.PreDestroy;
import javax.el.ELContext;
import javax.faces.context.FacesContext;

import org.eclipse.statet.rj.servi.RServi;
import org.eclipse.statet.rj.servi.node.RServiPool;
import org.eclipse.statet.rj.servi.pool.PoolServer;
import org.eclipse.statet.rj.servi.pool.RServiPoolManager;


public class DebugBean {
	
	
	private final List<RServi> nodes= new ArrayList<>();
	
	
	public DebugBean() {
	}
	
	
	@PreDestroy
	public void destroy() {
		actionCloseAllNodes();
	}
	
	
	public String actionNewNode() {
		final PoolServer poolServer= FacesUtils.getPoolServer();
		final RServiPoolManager poolManager= poolServer.getManager();
		
		if (poolManager == null) {
			FacesUtils.addErrorMessage(null, "The pool is currently not available.");
			return null;
		}
		try {
			final RServi rservi= ((RServiPool) poolManager).getRServi("control-web-app", null);
			synchronized(this) {
				this.nodes.add(rservi);
			}
		}
		catch (final Exception e) {
			FacesUtils.addErrorMessage(null, "An error occurred getting a node: " + e.getMessage());
		}
		refreshPoolStatus();
		return null;
	}
	
	public String actionCloseAllNodes() {
		synchronized (this) {
			for (final Iterator<RServi> iter= this.nodes.iterator(); iter.hasNext(); ) {
				final RServi rservi= iter.next();
				iter.remove();
				try {
					rservi.close();
				}
				catch (final Exception e) {
					FacesUtils.addErrorMessage(null, "An error occurred closing a node: " +e.getMessage());
				}
			}
		}
		
		refreshPoolStatus();
		return RJWeb.POOLSTATUS_NAV;
	}
	
	private void refreshPoolStatus() {
		final FacesContext context= FacesContext.getCurrentInstance();
		if (context != null) {
			try {
				final ELContext elContext= context.getELContext();
				final PoolStatusBean poolStatus= (PoolStatusBean) elContext.getELResolver().getValue(elContext, null, "poolStatus");
				if (poolStatus != null) {
					poolStatus.forceRefresh();
				}
			}
			catch (final Exception exception) {}
		}
	}
	
}

servi/org.eclipse.statet.rj.servi.webapp/src/main/java/org/eclipse/statet/rj/servi/webapp/NetConfigBean.java
/*=============================================================================#
 # Copyright (c) 2009, 2022 Stephan Wahlbrink and others.
 # 
 # This program and the accompanying materials are made available under the
 # terms of the Eclipse Public License 2.0 which is available at
 # https://www.eclipse.org/legal/epl-2.0, or the Apache License, Version 2.0
 # which is available at https://www.apache.org/licenses/LICENSE-2.0.
 # 
 # SPDX-License-Identifier: EPL-2.0 OR Apache-2.0
 # 
 # Contributors:
 #     Stephan Wahlbrink <sw@wahlbrink.eu> - initial API and implementation
 #=============================================================================*/

package org.eclipse.statet.rj.servi.webapp;

import javax.annotation.PostConstruct;
import javax.management.OperationsException;
import javax.naming.directory.InvalidAttributeValueException;

import org.eclipse.statet.rj.servi.pool.NetConfig;
import org.eclipse.statet.rj.servi.pool.PoolServer;


public class NetConfigBean extends NetConfig {
	
	
	public NetConfigBean() {
	}
	
	
	@PostConstruct
	public void init() {
		FacesUtils.loadFromFile(this, false);
	}
	
	
	public String getEffectivePoolAddress() {
		final String address= getPoolAddress(this, FacesUtils.getPoolId());
		return (address != null) ? address : "";
	}
	
	
	public String actionLoadCurrent() {
		final PoolServer poolServer= FacesUtils.getPoolServer();
		
		synchronized (this) {
			poolServer.getNetConfig(this);
			FacesUtils.validate(this);
		}
		
		return RJWeb.NETCONFIG_NAV;
	}
	
	public String actionLoadDefaults() throws InvalidAttributeValueException {
		synchronized (this) {
			load(new NetConfigBean());
			FacesUtils.validate(this);
		}
		
		return RJWeb.NETCONFIG_NAV;
	}
	
	public String actionRestart() {
		final NetConfig config= new NetConfig(this);
		
		if (!FacesUtils.validate(config)) {
			return null;
		}
		
		final PoolServer poolServer= FacesUtils.getPoolServer();
		
		poolServer.setNetConfig(config);
		try {
			poolServer.restart();
		}
		catch (final OperationsException e) {
			FacesUtils.addErrorMessage(null, e.getMessage());
		}
		return null;
	}
	
	public String actionSave() {
		FacesUtils.saveToFile(this);
		return null;
	}
	
}

servi/org.eclipse.statet.rj.servi.webapp/src/main/java/org/eclipse/statet/rj/servi/webapp/NodeConfigBean.java
/*=============================================================================#
 # Copyright (c) 2009, 2022 Stephan Wahlbrink and others.
 # 
 # This program and the accompanying materials are made available under the
 # terms of the Eclipse Public License 2.0 which is available at
 # https://www.eclipse.org/legal/epl-2.0, or the Apache License, Version 2.0
 # which is available at https://www.apache.org/licenses/LICENSE-2.0.
 # 
 # SPDX-License-Identifier: EPL-2.0 OR Apache-2.0
 # 
 # Contributors:
 #     Stephan Wahlbrink <sw@wahlbrink.eu> - initial API and implementation
 #=============================================================================*/

package org.eclipse.statet.rj.servi.webapp;

import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;

import org.eclipse.statet.rj.RjException;
import org.eclipse.statet.rj.servi.node.RServiNodeConfig;
import org.eclipse.statet.rj.servi.pool.PoolServer;


public class NodeConfigBean extends RServiNodeConfig {
	
	
	public NodeConfigBean() {
	}
	
	
	@PostConstruct
	public void init() {
		actionLoadCurrent();
	}
	
	
	public synchronized String getRLibsVariable() {
		return getEnvironmentVariables().get("R_LIBS");
	}
	
	public synchronized void setRLibsVariable(final String value) {
		if (value != null && value.length() > 0) {
			getEnvironmentVariables().put("R_LIBS", value);
		}
		else {
			getEnvironmentVariables().remove("R_LIBS");
		}
	}
	
	
	public String actionLoadCurrent() {
		final PoolServer poolServer= FacesUtils.getPoolServer();
		
		synchronized (this) {
			poolServer.getNodeConfig(this);
			FacesUtils.validate(this);
		}
		
		return RJWeb.RCONFIG_NAV;
	}
	
	public String actionLoadDefaults() {
		synchronized (this) {
			load(new RServiNodeConfig());
			FacesUtils.validate(this);
		}
		
		return RJWeb.RCONFIG_NAV;
	}
	
	public String actionApply() {
		final RServiNodeConfig config= new RServiNodeConfig(this);
		
		if (!FacesUtils.validate(config)) {
			return null;
		}
		final PoolServer poolServer= FacesUtils.getPoolServer();
		
		try {
			poolServer.setNodeConfig(config);
			FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, "Configuration applied.", null));
		}
		catch (final RjException e) {
			FacesUtils.addErrorMessage(null, e.getMessage());
		}
		return null;
	}
	
	public synchronized String actionSaveAndApply() {
		final RServiNodeConfig config= new RServiNodeConfig(this);
		
		if (!FacesUtils.validate(config)) {
			return null;
		}
		final PoolServer poolServer= FacesUtils.getPoolServer();
		
		try {
			poolServer.setNodeConfig(config);
			FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, "Configuration applied.", null));
		}
		catch (final RjException e) {
			FacesUtils.addErrorMessage(null, e.getMessage());
			return null;
		}
		FacesUtils.saveToFile(config);
		return null;
	}
	
}

servi/org.eclipse.statet.rj.servi.webapp/src/main/java/org/eclipse/statet/rj/servi/webapp/PoolConfigBean.java
/*=============================================================================#
 # Copyright (c) 2009, 2022 Stephan Wahlbrink and others.
 # 
 # This program and the accompanying materials are made available under the
 # terms of the Eclipse Public License 2.0 which is available at
 # https://www.eclipse.org/legal/epl-2.0, or the Apache License, Version 2.0
 # which is available at https://www.apache.org/licenses/LICENSE-2.0.
 # 
 # SPDX-License-Identifier: EPL-2.0 OR Apache-2.0
 # 
 # Contributors:
 #     Stephan Wahlbrink <sw@wahlbrink.eu> - initial API and implementation
 #=============================================================================*/

package org.eclipse.statet.rj.servi.webapp;

import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;

import org.eclipse.statet.rj.servi.pool.PoolConfig;
import org.eclipse.statet.rj.servi.pool.PoolServer;


public class PoolConfigBean extends PoolConfig {
	
	
	public PoolConfigBean() {
	}
	
	
	@PostConstruct
	public void init() {
		final PoolServer poolServer= FacesUtils.getPoolServer();
		
		poolServer.getPoolConfig(this);
	}
	
	
	public String actionLoadCurrent() {
		final PoolServer poolServer= FacesUtils.getPoolServer();
		
		synchronized (this) {
			poolServer.getPoolConfig(this);
			FacesUtils.validate(this);
		}
		
		return RJWeb.POOLCONFIG_NAV;
	}
	
	public String actionLoadDefaults() {
		synchronized (this) {
			load(new PoolConfig());
			FacesUtils.validate(this);
		}
		
		return RJWeb.POOLCONFIG_NAV;
	}
	
	public String actionApply() {
		final PoolConfig config= new PoolConfig(this);
		
		if (!FacesUtils.validate(config)) {
			return null;
		}
		final PoolServer poolServer= FacesUtils.getPoolServer();
		
		poolServer.setPoolConfig(config);
		FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, "Configuration applied.", null));
		return null;
	}
	
	public String actionSaveAndApply() {
		final PoolConfig config= new PoolConfig(this);
		
		if (!FacesUtils.validate(config)) {
			return null;
		}
		final PoolServer poolServer= FacesUtils.getPoolServer();
		
		poolServer.setPoolConfig(config);
		FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, "Configuration applied.", null));
		
		FacesUtils.saveToFile(config);
		return null;
	}
	
}

servi/org.eclipse.statet.rj.servi.webapp/src/main/java/org/eclipse/statet/rj/servi/webapp/PoolItemBean.java
/*=============================================================================#
 # Copyright (c) 2009, 2022 Stephan Wahlbrink and others.
 # 
 # This program and the accompanying materials are made available under the
 # terms of the Eclipse Public License 2.0 which is available at
 # https://www.eclipse.org/legal/epl-2.0, or the Apache License, Version 2.0
 # which is available at https://www.apache.org/licenses/LICENSE-2.0.
 # 
 # SPDX-License-Identifier: EPL-2.0 OR Apache-2.0
 # 
 # Contributors:
 #     Stephan Wahlbrink <sw@wahlbrink.eu> - initial API and implementation
 #=============================================================================*/

package org.eclipse.statet.rj.servi.webapp;

import java.time.Instant;

import org.eclipse.statet.jcommons.lang.NonNullByDefault;
import org.eclipse.statet.jcommons.lang.Nullable;
import org.eclipse.statet.jcommons.rmi.RMIAddress;

import org.eclipse.statet.rj.RjException;
import org.eclipse.statet.rj.servi.pool.PoolConfig;
import org.eclipse.statet.rj.servi.pool.PoolNodeItem;
import org.eclipse.statet.rj.servi.pool.PoolNodeObject;
import org.eclipse.statet.rj.servi.pool.PoolServer;


@NonNullByDefault
public class PoolItemBean extends PoolNodeItem {
	
	
	public PoolItemBean(final PoolNodeObject poolObj, final Instant stamp) {
		super(poolObj, stamp);
	}
	
	
	public @Nullable String getRMIAddress() {
		final RMIAddress address= getAddress();
		return (address != null) ? address.getAddress() : null;
	}
	
	
	public @Nullable String actionEnableConsole() {
		try {
			super.enableConsole("none");
		}
		catch (final RjException e) {
			FacesUtils.addErrorMessage(null, e.getMessage());
		}
		return null;
	}
	
	public @Nullable String actionDisableConsole() {
		try {
			super.disableConsole();
		}
		catch (final RjException e) {
			FacesUtils.addErrorMessage(null, e.getMessage());
		}
		return null;
	}
	
	public void actionStop() {
		final PoolServer poolServer= FacesUtils.getPoolServer();
		
		final PoolConfig config= new PoolConfig();
		poolServer.getPoolConfig(config);
		
		evict(config.getEvictionTimeout());
	}
	
	public void actionKill() {
		evict(null);
	}
	
}

servi/org.eclipse.statet.rj.servi.webapp/src/main/java/org/eclipse/statet/rj/servi/webapp/PoolStatusBean.java
/*=============================================================================#
 # Copyright (c) 2009, 2022 Stephan Wahlbrink and others.
 # 
 # This program and the accompanying materials are made available under the
 # terms of the Eclipse Public License 2.0 which is available at
 # https://www.eclipse.org/legal/epl-2.0, or the Apache License, Version 2.0
 # which is available at https://www.apache.org/licenses/LICENSE-2.0.
 # 
 # SPDX-License-Identifier: EPL-2.0 OR Apache-2.0
 # 
 # Contributors:
 #     Stephan Wahlbrink <sw@wahlbrink.eu> - initial API and implementation
 #=============================================================================*/

package org.eclipse.statet.rj.servi.webapp;

import java.time.Instant;

import javax.annotation.PostConstruct;

import org.eclipse.statet.jcommons.lang.NonNullByDefault;
import org.eclipse.statet.jcommons.lang.Nullable;

import org.eclipse.statet.rj.servi.pool.PoolNodeItem;
import org.eclipse.statet.rj.servi.pool.PoolNodeObject;
import org.eclipse.statet.rj.servi.pool.PoolStatus;
import org.eclipse.statet.rj.servi.pool.RServiPoolManager;


@NonNullByDefault
public class PoolStatusBean extends PoolStatus<PoolItemBean> {
	
	
	private boolean forceRefresh;
	private boolean autoRefresh;
	
	
	public PoolStatusBean() {
		super(FacesUtils.getPoolServer());
	}
	
	
	@PostConstruct
	public void init() {
		load();
	}
	
	private void load() {
		final Instant stamp= Instant.now();
		final RServiPoolManager poolManager= this.server.getManager();
		if (poolManager == null) {
			FacesUtils.addErrorMessage(null, "The pool is currently not available.");
		}
		refresh(poolManager, stamp);
	}
	
	@Override
	protected PoolNodeItem createPoolItem(final PoolNodeObject itemData, final Instant stamp) {
		return new PoolItemBean(itemData, stamp);
	}
	
	@Override
	protected PoolItemBean createNodeState(final PoolNodeItem item) {
		return (PoolItemBean) item;
	}
	
	
	public synchronized Instant getStamp() {
		check();
		return super.getStatusStamp();
	}
	
	@Override
	protected void check() {
		if (this.forceRefresh) {
			load();
		}
	}
	
	public synchronized void forceRefresh() {
		this.forceRefresh= true;
	}
	
	
	public @Nullable String actionRefresh() {
		return null;
	}
	
	public synchronized @Nullable String actionEnableAutoRefresh() {
		this.autoRefresh= true;
		return null;
	}
	
	public synchronized @Nullable String actionDisableAutoRefresh() {
		this.autoRefresh= false;
		return null;
	}
	
	public synchronized void setAutoRefreshEnabled(final boolean enabled) {
		this.autoRefresh= enabled;
	}
	
	public synchronized boolean isAutoRefreshEnabled() {
		return this.autoRefresh;
	}
	
}

servi/org.eclipse.statet.rj.servi.webapp/src/main/webapp/resources/index.jsp
<?xml version="1.0" encoding="ISO-8859-1" ?>
<%@page language="java" contentType="text/html; charset=ISO-8859-1"
    pageEncoding="ISO-8859-1"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib uri="http://java.sun.com/jsf/html" prefix="h" %>
<%@taglib uri="http://java.sun.com/jsf/core" prefix="f" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%--
 #=============================================================================#
 # Copyright (c) 2009, 2022 Stephan Wahlbrink and others.
 # 
 # This program and the accompanying materials are made available under the
 # terms of the Eclipse Public License 2.0 which is available at
 # https://www.eclipse.org/legal/epl-2.0, or the Apache License, Version 2.0
 # which is available at https://www.apache.org/licenses/LICENSE-2.0.
 # 
 # SPDX-License-Identifier: EPL-2.0 OR Apache-2.0
 # 
 # Contributors:
 #     Stephan Wahlbrink <sw@wahlbrink.eu> - initial API and implementation
 #=============================================================================#
--%>
<f:view>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
<meta http-equiv="Content-Style-Type" content="text/css" />
<link rel="stylesheet" type="text/css" href="css/style.css" />

<title>(RJ) Welcome</title>
</head>
<body>
<%@include file="body-header.jspf" %>

<h2>Welcome</h2>

<table class="grid">
<tr><th colspan="2" scope="colgroup">Links</th></tr>
<tr><td>StatET Project</td><td><a href="https://www.eclipse.org/statet">www.eclipse.org/statet</a></td></tr>
<tr><td>R Project</td><td><a href="http://www.r-project.org">www.r-project.org</a></td></tr>
</table>

<table class="grid">
<tr><th colspan="2" scope="colgroup">Sources</th></tr>
<tr><td>RJ</td><td><a href="http://git.eclipse.org/c/statet/org.eclipse.statet-rj.git">git.eclipse.org/c/statet/org.eclipse.statet-rj.git</a></td></tr>
</table>

<hr/>

<p>
Copyright (c) 2007, 2022 Stephan Wahlbrink and others.</p>
<p>
This product includes software developed by The Apache Software Foundation
(<a href="https://www.apache.org">www.apache.org</a>).</p>

<%@include file="body-footer.jspf" %>
</body>
</html>
</f:view>

servi/org.eclipse.statet.rj.servi.webapp/src/main/webapp/resources/status-poolnodes.jsp
<?xml version="1.0" encoding="ISO-8859-1" ?>
<%@page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib uri="http://java.sun.com/jsf/html" prefix="h" %>
<%@taglib uri="http://java.sun.com/jsf/core" prefix="f" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%--
 #=============================================================================#
 # Copyright (c) 2009, 2022 Stephan Wahlbrink and others.
 # 
 # This program and the accompanying materials are made available under the
 # terms of the Eclipse Public License 2.0 which is available at
 # https://www.eclipse.org/legal/epl-2.0, or the Apache License, Version 2.0
 # which is available at https://www.apache.org/licenses/LICENSE-2.0.
 # 
 # SPDX-License-Identifier: EPL-2.0 OR Apache-2.0
 # 
 # Contributors:
 #     Stephan Wahlbrink <sw@wahlbrink.eu> - initial API and implementation
 #=============================================================================#
--%>
<f:view>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
<meta http-equiv="Content-Style-Type" content="text/css" />
<link rel="stylesheet" type="text/css" href="css/style.css" />

<title>(RJ) Status: Overview Pool Nodes</title>
</head>

<body onload="<c:if test="${poolStatus.autoRefreshEnabled}">window.setTimeout('javascript:document.getElementById(\'pool_nodes:refresh\').click()', 5000)</c:if>">

<%@include file="body-header.jspf" %>

<h2>Status: Current Pool Nodes</h2>

<h:panelGrid columns="2" styleClass="grid" columnClasses=",," style="border-bottom: 2px solid black">
	<h:outputLabel for="eff_pool_address" value="RMI pool address:" />
	<h:inputText id="eff_pool_address" value="#{netConfig.effectivePoolAddress}" readonly="true" size="40" />
</h:panelGrid>

<h:form id="pool_nodes">
	<h:messages errorClass="error" />
	
<h:inputHidden value="#{poolStatus.autoRefreshEnabled}" immediate="true" />
<h:commandButton id="refresh" value="Refresh" action="#{poolStatus.actionRefresh}" />
<c:if test="${!poolStatus.autoRefreshEnabled}">
<h:commandButton id="enableAutoRefresh" value="Enable Auto Refresh" action="#{poolStatus.actionEnableAutoRefresh}" />
</c:if>
<c:if test="${poolStatus.autoRefreshEnabled}">
<h:commandButton id="disableAutoRefresh" value="Disable Auto Refresh" action="#{poolStatus.actionDisableAutoRefresh}" immediate="true" />
</c:if>

<br/>

<h:panelGrid columns="3" styleClass="table1" columnClasses=",alignright,alignright">
	<f:facet name="header"><h:outputText value="Summary" /></f:facet>
	
	<h:outputText />
	<h:outputText value="Current" />
	<h:outputText value="Max" />
	
	<h:outputText value="Idling:" />
	<h:outputText value="#{poolStatus.numIdling}" />
	<h:outputText value="#{poolStatus.maxIdling}" />
	
	<h:outputText value="In use:" />
	<h:outputText value="#{poolStatus.numInUse}" />
	<h:outputText value="#{poolStatus.maxInUse}" />
	
	<h:outputText value="Total:" />
	<h:outputText value="#{poolStatus.numTotal}" />
	<h:outputText value="#{poolStatus.maxTotal}" />
</h:panelGrid>
	
<br/>
	
<h:dataTable value="#{poolStatus.nodeStates}" var="dataItem" styleClass="table1" columnClasses=",,spanleft,,alignright">
	<h:column>
		<f:facet name="header">
			<h:outputText value="Created" />
		</f:facet>
		<h:outputText value="#{dataItem.creationTime}" >
			<f:convertDateTime pattern="yyyy-MM-dd HH:mm:ss"/> 
		</h:outputText>
	</h:column>
	
	<h:column>
		<f:facet name="header">
			<h:outputText value="State" />
		</f:facet>
		<h:outputText value="#{dataItem.state}" />
	</h:column>
	
	<h:column headerClass="spanleft">
		<f:facet name="header">
			<h:outputText value="" />
		</f:facet>
		(<h:outputText value="#{dataItem.stateTime - poolStatus.stamp}" >
			<f:converter converterId="convertDuration" /> 
		</h:outputText>)
	</h:column>
	
	<h:column>
		<f:facet name="header">
			<h:outputText value="Client" />
		</f:facet>
		<h:outputText value="#{dataItem.currentClientLabel}" />
	</h:column>
	
	<h:column>
		<f:facet name="header">
			<h:outputText value="Usage" />
		</f:facet>
		<h:outputText value="#{dataItem.usageCount}" />
	</h:column>
	
	<h:column>
		<f:facet name="header">
			<h:outputText value="Debug Console" />
		</f:facet>
		<h:selectBooleanCheckbox value="#{dataItem.consoleEnabled}" readonly="true" disabled="true" />
		<h:inputText value="#{dataItem.RMIAddress}" readonly="true" size="40" />
		<h:outputText value=" " />
		<h:commandLink value="On" action="#{dataItem.actionEnableConsole}" rendered="#{!dataItem.consoleEnabled}" />
		<h:commandLink value="Off" action="#{dataItem.actionDisableConsole}" rendered="#{dataItem.consoleEnabled}" />
	</h:column>
	
	<h:column>
		<f:facet name="header">
			<h:outputText value="Evict" />
		</f:facet>
		<h:commandLink value="Stop" action="#{dataItem.actionStop}" />
		<h:outputText value=" " />
		<h:commandLink value="Kill" action="#{dataItem.actionKill}" />
	</h:column>
	
</h:dataTable>

<h:panelGrid columns="2" styleClass="grid" columnClasses=",info">
	<f:facet name="header"><h:outputText value="Test Actions" /></f:facet>
	
	<h:commandLink action="#{debug.actionNewNode}" immediate="true">Get node (<code>RServiPool#getRServi</code>)</h:commandLink>
	<h:outputText value="acquire node from pool" />
	
	<h:commandLink action="#{debug.actionCloseAllNodes}" immediate="true">Close all nodes (<code>RServi#close</code>)</h:commandLink>
	<h:outputText value="return acquired nodes to pool" />
</h:panelGrid>
	
</h:form>

<%@include file="body-footer.jspf" %>
</body>
</html>
</f:view>